import java.util.*;

/**
 * The test class PhoneMapTest.
 *
 * @author  (your name)
 * @version (a version number or a date)
 */
public class PhoneMapTest extends junit.framework.TestCase
{
    /**
     * Default constructor for test class PhoneMapTest
     */
    public PhoneMapTest()
    {
    }

    /**
     * Sets up the test fixture.
     *
     * Called before every test case method.
     */
    protected void setUp()
    {
    }

    public void testTranslate()
    {
        PhoneMap phoneMap1 = new PhoneMap();
        assertEquals("222333", phoneMap1.translate("abcdef"));
        assertEquals("444555", phoneMap1.translate("ghijkl"));
        assertEquals("6667777", phoneMap1.translate("mnopqrs"));
        assertEquals("8889999", phoneMap1.translate("tuvwxyz"));
    }

    public void testAddNum()
    {
        PhoneMap phoneMap1 = new PhoneMap();
        assertEquals(1, phoneMap1.addNumber("222", "aaa"));
        assertEquals(2, phoneMap1.addNumber("222", "bbb"));
        assertEquals(1, phoneMap1.addNumber("333", "ddd"));
        assertEquals(2, phoneMap1.addNumber("333", "eee"));
        assertEquals(3, phoneMap1.addNumber("333", "def"));
        assertEquals(1, phoneMap1.addNumber("444", "ghi"));
        assertEquals(4, phoneMap1.addNumber("333", "fff"));
        assertEquals(1, phoneMap1.addNumber("9", "z"));
    }
    public void testUpdate()
    {
        PhoneMap phoneMap1 = new PhoneMap();
        phoneMap1.updateHighCount("222",1);
        phoneMap1.updateHighCount("222",2);
        phoneMap1.updateHighCount("333",1);
        List<String> actual = phoneMap1.getResults();
        assertTrue(actual.contains("222"));
        assertEquals(1, actual.size());
        phoneMap1.updateHighCount("333",2);
        phoneMap1.updateHighCount("333",3);
        actual = phoneMap1.getResults();
        assertTrue(actual.contains("333"));
        assertEquals(1, actual.size());
        phoneMap1.updateHighCount("222",3);
        actual = phoneMap1.getResults();
        assertEquals("222",actual.get(0));
        assertEquals("333",actual.get(1));
        assertEquals(2, actual.size());
    }
    public void testGetWords()
    {
        PhoneMap phoneMap1 = new PhoneMap();
        assertEquals(1, phoneMap1.addNumber("222", "aaa"));
        assertEquals(2, phoneMap1.addNumber("222", "bbb"));
        assertEquals(1, phoneMap1.addNumber("333", "ddd"));
        List<String> actual = phoneMap1.getWordsForAcct("333");      
        assertTrue(actual.contains("ddd"));
        assertEquals(1, actual.size());
        actual = phoneMap1.getWordsForAcct("222");      
        assertEquals("aaa",actual.get(0));
        assertEquals("bbb",actual.get(1));
        assertEquals(2, actual.size());
    }
    public void testGetMultipleWords()
    {
        PhoneMap phoneMap1 = new PhoneMap();
        assertEquals(1, phoneMap1.addNumber("222", "aaa"));
        assertEquals(2, phoneMap1.addNumber("222", "bbb"));
        assertEquals(1, phoneMap1.addNumber("333", "ddd"));
        assertEquals(2, phoneMap1.addNumber("333", "eee"));
        assertEquals(3, phoneMap1.addNumber("333", "def"));
        assertEquals(1, phoneMap1.addNumber("444", "ghi"));
        assertEquals(4, phoneMap1.addNumber("333", "fff"));
        assertEquals(1, phoneMap1.addNumber("9", "z"));
        List<String> actual = phoneMap1.getWordsForAcct("333");      
        assertEquals("ddd",actual.get(0));
        assertEquals("fff",actual.get(3));
        assertEquals(4, actual.size());
        actual = phoneMap1.getWordsForAcct("9");        
        assertTrue(actual.contains("z"));
        assertEquals(1, actual.size());
        System.out.println(phoneMap1);
    }
    public void testAllOne()
    {
        PhoneMap phoneMap1 = new PhoneMap();
        assertEquals(1, phoneMap1.addNumber("222", "abc"));
        phoneMap1.updateHighCount("222",1);
        List<String> results = phoneMap1.getResults();
        assertTrue(results.contains("222"));
        assertEquals(1, results.size());
        List<String> actual = phoneMap1.getWordsForAcct("222");
        assertTrue(actual.contains("abc"));
        assertEquals(1, actual.size());
    }
}



